//+------------------------------------------------------------------+
//|                                             Multi Sync Index.mq4 |
//|                                         Indicator Made by Jas Wu |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property description "Multi Sync Index"
#property description "Indicator Made by Jas Wu"
#property copyright "Check out my Ultimate NNFX Backtester"
#property link      "https://www.mql5.com/en/market/product/52403"
#property version   "1.00"
#property strict
#property indicator_separate_window
#property indicator_buffers 1
#property indicator_level1 0
#property indicator_level2 0
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+

extern string LinkTo_Backtester = "https://www.mql5.com/en/market/product/52403"; //Check out my Ultimate NNFX Backtester
extern int RSI = 21; //RSI Period
extern int CCI = 21; //CCI Period
extern int WPR = 21; //WPR Period
extern int ADX = 21; //ADX Period
extern int Force = 21; //Force Period
extern int Momentum = 21; //Momentum Period
extern int Demarker = 21; //DeMarker Period
extern int RVI = 21; //RVI Period
extern int Bull = 21; //Bulls Power Period
extern int Bear = 21; //Bears Power Period
extern double PSARStep = 0.02; //Parabolic SAR Step
extern double PSARMaximum = 0.1; //Parabolic SAR Maximum
extern int KijunSen = 14;
extern string Notes = "------------------Fixed Level Filter----------------"; //-
extern double Filter1 = 2.0; //Up Filter Fixed Level
extern double Filter2 = -2.0; //Down Filter Fixed Level

enum MAMethod {
SMA=MODE_SMA, // Simple Moving Average
EMA=MODE_EMA, // Exponential Moving Average
SMMA=MODE_SMMA, // Smoothed Moving Average
LWMA=MODE_LWMA // Linear Weighted Moving Average
};

extern string Notess = "-----------------Ma Options------------------"; //-
extern MAMethod MaMethod = LWMA; //MA Method(for some indicators only)

double SynIndex[];
int maMethod = MaMethod; 
int barstocursor=0;
string UprDown = " ";

int OnInit()
  {
//--- indicator buffers mapping
 ChartSetInteger(0,CHART_EVENT_MOUSE_MOVE,true);
 IndicatorShortName("Multi Sync Index");
 IndicatorDigits(Digits);
 IndicatorBuffers(1);

   SetIndexStyle(0,DRAW_HISTOGRAM, STYLE_SOLID, 3, clrCrimson);
   SetIndexBuffer(0,SynIndex);
   SetIndexLabel(0, "SynIndex");    
            
   SetLevelValue(0, Filter1);
   SetLevelValue(1, Filter2);         
   
   ObjectCreate("Sync", OBJ_LABEL, ChartWindowFind(0, "Multi Sync Index"), 0, 0, 0, 0);
   ObjectSetText("Sync", "gggg", 20, "Webdings", clrBlack);   
   ObjectSet("Sync", OBJPROP_CORNER, 0);
   ObjectSet("Sync", OBJPROP_XDISTANCE, 5);
   ObjectSet("Sync", OBJPROP_YDISTANCE, 20);
   ObjectSet("Sync", OBJPROP_BACK, false);        
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//---
   
 int ExtCountedBars=IndicatorCounted();
 if (ExtCountedBars<0) return(-1);
 int pos;
 int limit=Bars-1;
 if(ExtCountedBars>2) limit=Bars-ExtCountedBars-1;
 pos=limit;
 
 
      for(int j=0; j<=limit; j++)
      {
            SynIndex[j] = 0;
            if( iRSI(_Symbol, _Period, RSI, PRICE_CLOSE, j) > 50 ) SynIndex[j] += 1;  if( iRSI(_Symbol, _Period, RSI, PRICE_CLOSE, j) < 50 ) SynIndex[j] -= 1;
            if( iForce(_Symbol, _Period, Force, maMethod, PRICE_CLOSE, j) > 0 ) SynIndex[j] += 1;  if( iForce(_Symbol, _Period, Force, maMethod, PRICE_CLOSE, j) < 0 ) SynIndex[j] -= 1;
            if( iWPR(_Symbol, _Period, WPR, j) > -50 ) SynIndex[j] += 1; if( iWPR(_Symbol, _Period, WPR, j) < -50 ) SynIndex[j] -= 1;
            if( iCCI(_Symbol, _Period, CCI, PRICE_CLOSE, j) > 0) SynIndex[j] += 1; if( iCCI(_Symbol, _Period, CCI, PRICE_CLOSE, j) < 0) SynIndex[j] -= 1; 
            if( iBearsPower(_Symbol, _Period, Bear, PRICE_CLOSE, j) > 0) SynIndex[j] -= 2; if( Close[j] > iIchimoku(_Symbol, _Period, 9, KijunSen, 52, MODE_KIJUNSEN, j) ) SynIndex[j] += 2; 
            if( iBullsPower(_Symbol, _Period, Bull, PRICE_CLOSE, j) > 0) SynIndex[j] += 2; if( Close[j] < iIchimoku(_Symbol, _Period, 9, KijunSen, 52, MODE_KIJUNSEN, j) ) SynIndex[j] -= 2; 
            if( iSAR(_Symbol, _Period, PSARStep, PSARMaximum, j) > Close[j]) SynIndex[j] -= 2; if( iSAR(_Symbol, _Period, PSARStep, PSARMaximum, j) < Close[j]) SynIndex[j] += 2;   
            if( iADX(_Symbol, _Period, ADX, PRICE_CLOSE, MODE_PLUSDI, j) > iADX(_Symbol, _Period, ADX, PRICE_CLOSE, MODE_MINUSDI, j) ) SynIndex[j] += 2;
            if( iADX(_Symbol, _Period, ADX, PRICE_CLOSE, MODE_PLUSDI, j) < iADX(_Symbol, _Period, ADX, PRICE_CLOSE, MODE_MINUSDI, j) ) SynIndex[j] -= 2;      
            if( iRVI(_Symbol, _Period, RVI, MODE_MAIN, j) > iRVI(_Symbol, _Period, RVI, MODE_SIGNAL, j) ) SynIndex[j] += 2;
            if( iRVI(_Symbol, _Period, RVI, MODE_MAIN, j) < iRVI(_Symbol, _Period, RVI, MODE_SIGNAL, j) ) SynIndex[j] -= 2;
            if( iDeMarker(_Symbol, _Period, Demarker, j) > 0.5 ) SynIndex[j] += 1; if( iDeMarker(_Symbol, _Period, Demarker, j) < 0.5 ) SynIndex[j] -= 1;
            if( iMomentum(_Symbol, _Period, Momentum, PRICE_CLOSE, j) > 100 ) SynIndex[j] += 1; if( iMomentum(_Symbol, _Period, Momentum, PRICE_CLOSE, j) < 100 ) SynIndex[j] -= 1;
      }
   
      
//--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+

void OnChartEvent(const int id,
                  const long &lparam,
                  const double &dparam,
                  const string &sparam)
{

      if(id==CHARTEVENT_MOUSE_MOVE) 
        { 
         //--- Prepare variables 
         int      x     =(int)lparam; 
         int      y     =(int)dparam; 
         datetime dt    =0; 
         double   price =0; 
         int      window=0; 
         
         //--- Convert the X and Y coordinates in terms of date/time 
         if(ChartXYToTimePrice(0,x,y,window,dt,price)) 
           { 
               barstocursor=Bars(NULL, 0, dt, iTime(NULL, 0, 0))-1;
            
                     //--- Tell Direction Text
                     if(SynIndex[barstocursor] > 0) UprDown = "UpTrend";
                     if(SynIndex[barstocursor] < 0) UprDown = "DownTrend";  
                     if(SynIndex[barstocursor] == 0) UprDown = "No Trend";                       
                     
                     //--- Create Text 
                     ObjectCreate("Sync1", OBJ_LABEL, ChartWindowFind(0, "Multi Sync Index"), 0, 0, 0, 0);
                     if(SynIndex[barstocursor] > 0) ObjectSetText("Sync1", UprDown, 14, "Arial", Lime);   
                     if(SynIndex[barstocursor] < 0) ObjectSetText("Sync1", UprDown, 14, "Arial", Crimson);
                     if(SynIndex[barstocursor] == 0) ObjectSetText("Sync1", UprDown, 14, "Arial", Gray);                                  
                     ObjectSet("Sync1", OBJPROP_CORNER, 0);
                     ObjectSet("Sync1", OBJPROP_XDISTANCE, 15);
                     ObjectSet("Sync1", OBJPROP_YDISTANCE, 20);
                     ObjectSet("Sync1", OBJPROP_BACK, false); 
                            
            
           }     
        }
     
}
         